Index: trunk/src/VBox/ValidationKit/utils/audio/vkat.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/vkat.cpp	(revision 107908)
+++ trunk/src/VBox/ValidationKit/utils/audio/vkat.cpp	(revision 107909)
@@ -171,10 +171,11 @@
 static const RTGETOPTDEF g_aCmdCommonOptions[] =
 {
-    { "--quiet",            'q',                                        RTGETOPT_REQ_NOTHING },
-    { "--verbose",          'v',                                        RTGETOPT_REQ_NOTHING },
-    { "--daemonize",        AUDIO_TEST_OPT_CMN_DAEMONIZE,               RTGETOPT_REQ_NOTHING },
-    { "--daemonized",       AUDIO_TEST_OPT_CMN_DAEMONIZED,              RTGETOPT_REQ_NOTHING },
-    { "--debug-audio",      AUDIO_TEST_OPT_CMN_DEBUG_AUDIO_ENABLE,      RTGETOPT_REQ_NOTHING },
-    { "--debug-audio-path", AUDIO_TEST_OPT_CMN_DEBUG_AUDIO_PATH,        RTGETOPT_REQ_STRING  },
+    { "--quiet",                 'q',                                      RTGETOPT_REQ_NOTHING },
+    { "--verbose",               'v',                                      RTGETOPT_REQ_NOTHING },
+    { "--daemonize",             AUDIO_TEST_OPT_CMN_DAEMONIZE,             RTGETOPT_REQ_NOTHING },
+    { "--daemonized",            AUDIO_TEST_OPT_CMN_DAEMONIZED,            RTGETOPT_REQ_NOTHING },
+    { "--debug-audio",           AUDIO_TEST_OPT_CMN_DEBUG_AUDIO_ENABLE,    RTGETOPT_REQ_NOTHING },
+    { "--debug-audio-path",      AUDIO_TEST_OPT_CMN_DEBUG_AUDIO_PATH,      RTGETOPT_REQ_STRING  },
+    { "--drvhost-cache-enabled", AUDIO_TEST_OPT_CMN_DRVHOST_CACHE_ENABLED, RTGETOPT_REQ_BOOL    },
 };
 
@@ -236,5 +237,7 @@
 /** DrvAudio: The debug output path. */
 const char      *g_pszDrvAudioDebug = NULL;
-
+/** Whether the host audio driver backend's caching is enabled or not. Defaults to enabled.
+ *  Only implemented for DrvHostAudioWasApi backend so far, ignored otherwise. */
+bool             g_fDrvHostAudioCacheEnabled = true;
 
 /**
@@ -1313,4 +1316,6 @@
                  "  --debug-audio-path=<path>\n"
                  "    Tells DrvAudio where to put its debug output (wav-files)\n"
+                 "  --drvhost-cache-enabled=<true|false>\n"
+                 "    Enables or disables caching code for the host driver (backend)\n"
                  "  -q, --quiet\n"
                  "    Sets verbosity to zero\n"
Index: trunk/src/VBox/ValidationKit/utils/audio/vkatDriverStack.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/vkatDriverStack.cpp	(revision 107908)
+++ trunk/src/VBox/ValidationKit/utils/audio/vkatDriverStack.cpp	(revision 107909)
@@ -159,4 +159,6 @@
             && strcmp(pszName, "DebugEnabled") == 0)
             *pf = g_fDrvAudioDebug;
+        else if (strcmp(pszName, "CacheEnabled") == 0)
+            *pf = g_fDrvHostAudioCacheEnabled;
 
         if (g_uVerbosity > 2)
Index: trunk/src/VBox/ValidationKit/utils/audio/vkatInternal.h
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/vkatInternal.h	(revision 107908)
+++ trunk/src/VBox/ValidationKit/utils/audio/vkatInternal.h	(revision 107909)
@@ -386,4 +386,7 @@
 /** DrvAudio: The debug output path. */
 extern const char      *g_pszDrvAudioDebug;
+/** Whether the host audio driver backend's caching is enabled or not. Defaults to enabled.
+ *  Only implemented for DrvHostAudioWasApi backend so far, ignored otherwise. */
+extern bool             g_fDrvHostAudioCacheEnabled;
 
 extern const VKATCMD    g_CmdTest;
@@ -520,5 +523,6 @@
     AUDIO_TEST_OPT_CMN_DAEMONIZED,
     AUDIO_TEST_OPT_CMN_DEBUG_AUDIO_ENABLE,
-    AUDIO_TEST_OPT_CMN_DEBUG_AUDIO_PATH
+    AUDIO_TEST_OPT_CMN_DEBUG_AUDIO_PATH,
+    AUDIO_TEST_OPT_CMN_DRVHOST_CACHE_ENABLED
 };
 
@@ -545,6 +549,10 @@
                 break; \
             \
+            case AUDIO_TEST_OPT_CMN_DRVHOST_CACHE_ENABLED: \
+                g_fDrvHostAudioCacheEnabled = a_ValueUnion.f; \
+                break; \
+            \
             case AUDIO_TEST_OPT_CMN_DEBUG_AUDIO_PATH: \
-                g_pszDrvAudioDebug = (a_ValueUnion).psz; \
+                g_pszDrvAudioDebug = a_ValueUnion.psz; \
                 break; \
             case AUDIO_TEST_OPT_CMN_DAEMONIZE: \